
texture		textureA;

sampler2D samplerA = sampler_state
{
    Texture		= (textureA);  
    AddressU	= WRAP;
    AddressV	= WRAP;       
	MinFilter	= LINEAR;
	MagFilter	= LINEAR;
	MipFilter	= NONE;
};

float x, y, w, h;
float filletRadius;
float4 facecolor;

/*
float4 FlatQuadPS(in float2 vScreenPosition : TEXCOORD0) : COLOR
{
	float2 uv = vScreenPosition;
	float4 color =  tex2D(samplerA, uv);  

	float k = 1 - abs(uv.x - 0.5) * 2;
	float l = 1 - abs(uv.y - 0.5) * 2;

	float q = 0;

	color = facecolor;
	color.w = 1;

	float e = filletRadius / w;
	float f = filletRadius / h;

	float a = 1;
	if(uv.x < 0.5)
		a = -1;

	float b = 1;
	if(uv.y < 0.5)
		b = -1;


	k = (uv.x - 0.5) * 2;
	l = (uv.y - 0.5) * 2;

	color.xyz *= 0.8;
	color.xyz -= 0.5 * k *(pow(k, 8));
	return color;
}
*/



float4 FlatQuadPS(in float2 vScreenPosition : TEXCOORD0) : COLOR
{
	float2 uv = vScreenPosition;
	float4 color =  tex2D(samplerA, uv);  

	float k = 1 - abs(uv.x - 0.5) * 2;
	float l = 1 - abs(uv.y - 0.5) * 2;

	float q = 0;

	color = facecolor;
	color.w = 1;

	float e = filletRadius * 0.2 / w;
	float f = filletRadius * 0.2 / h;

	float ee = filletRadius  / w;
	float ff = filletRadius  / h;

	if((e > k)&&(f > l))
	{
		q = (length(float3(1-k/e,1-l/f,0)));
		if(q > 1)
		color.w = 0;
	}


	float a = 1;
	if(uv.x < 0.5)
		a = -1;

	if(k < ee)
	{
		k = ee - k;
		color.xyz -= a * k*k * 2;
	}

	/*
	k = (uv.x - 0.5) * 2;

	l = (uv.y - 0.5) * 2;

	color.xyz *= 0.8;
	color.xyz -= 0.5 * k *(pow(k, 8));
	*/
	return color;
}

technique FlatQuad
{
    pass P0
    {
		AlphaBlendEnable	= TRUE;
        PixelShader  = compile ps_2_0 FlatQuadPS();
    }	
}


		/*
		k = k/e;
		l = l/f;
		q = (length(float3(1-k,1-l,0)));
	
		if(q > 1)
		color.w = 1 / pow(q, 50);
		*/
	/*
	if((e > k)&&(f > l))
	{


		q = k + l;
		if(q > 1)
		color.w = 1 / pow(q, 50);
	}
*/
